'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.API = API;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var client = _axios2.default.create({
    withCredentials: true
});

function API(modelName) {

    return {

        /**
         * 获取客户端
         */
        getTransport: function getTransport() {
            return client;
        },

        /**
         * create model
         */
        create: function create(record) {
            return client.post('/' + modelName + '/create', JSON.stringify(record), {
                headers: { 'Content-Type': 'application/json' }
            }).then(function (resp) {
                return resp.data;
            }, function (e) {
                throw e;
            });
        },

        /**
         * remove model ,
         * 为了可以删除关联，不再仅仅只传递一个id了
         */
        remove: function remove(record) {
            return client.post('/' + modelName + '/remove', JSON.stringify(record), {
                headers: { 'Content-Type': 'application/json' }
            }).then(function (resp) {
                return resp.data;
            }, function (e) {
                throw e;
            });
        },

        /**
         * update model
         */
        update: function update(id, record) {
            record.id = id;
            return client.post('/' + modelName + '/update', JSON.stringify(record), {
                headers: { 'Content-Type': 'application/json' }
            }).then(function (resp) {
                return resp.data;
            }, function (e) {
                throw e;
            });
        },

        /**
         * list all models by page ,size ,condition
         */
        list: function list() {
            var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
            var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10;
            var condition = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            return client.post('/' + modelName + '/list', JSON.stringify({ page: page, size: size, condition: condition }), {
                headers: { 'Content-Type': 'application/json' }
            }).then(function (resp) {
                return resp.data;
            }, function (e) {
                throw e;
            });
        }

    };
};

exports.default = API;